package petruna.sps;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;

import javax.swing.JProgressBar;
import javax.swing.SwingUtilities;

public class MyFileUploader implements FileUploader {
	
	
	private UploadDisplayer uploadDisplayer;
	
	private String url;
	
	private int responseStatusCode;
	
	public MyFileUploader(UploadDisplayer uploadDisplayer, String url){
	this.uploadDisplayer=uploadDisplayer;
	this.url=url;
	}
	
	private void CreateConnection(){
	//TODO
	}
	
	private void CloseConnection(){
	//TODO
	}
	
	public int ResponseStatusCode(){
	return responseStatusCode;
	}
	
	public void UploadFiles(ArrayList fileList) {/*
		// TODO Auto-generated method stub
        /*
         * url
         */
        String url = "http://localhost:8080/upload";

        /*
         * http connection 
         */
        HttpURLConnection.setFollowRedirects(false);
        HttpURLConnection conn = null;
                  
            
        /* for each file, make an upload request
         * 
         */
        for (int i = 0; i < fileList.size(); i++ ) 
        {
          /*
           * check for interrupt
           */
          if ( Thread.currentThread().isInterrupted() )
          {
            continue;
          }
          
          File f = (File) fileList.get(i);                
           
          /*
           * display upload
           */
          final String msg;
          if(f.length()>1024){
              int fileSize = (int) Math.floor(  (double) f.length() / 1024 );
              msg = "Uploading " + f.getName() + " (" + fileSize + "kB) ...<br>";
              }else{
              	msg = "Uploading " + f.getName() + " (" + f.length() + "B) ...<br>";  
              }

          SwingUtilities.invokeLater( new Runnable(){
            public void run()
            {
              uploadDisplayer.display( msg );
            }
          });
          
          /*
           * for convenience
           */
          String currentFileName = f.getName();
          
          try 
          {         
            
            /*
             * create reusable connection
             */
            conn = (HttpURLConnection) new URL(url).openConnection();
                 
            /*
             * Create and setup our HTTP POST connection.  
             */    
            conn.setRequestMethod("POST");

            /*
             * boundary string
             */
            String boundary = "boundary220394209402349823";
            
            /*
             * tail string
             */
            String tail    = "\r\n--" + boundary + "--\r\n";              
            
            /*
             * Set content type
             */
            conn.setRequestProperty("Content-Type", "multipart/form-data; boundary=" + boundary );
            
            /*
             * We intend to send output to the server.
             */
            conn.setDoOutput(true);

            /*
             * Create metadata section 
             */
            String metadataPart = "currently nothing, could be used in future";      
           
            /*
             * Create file data header 
             */
            String fileHeader1 = "--" + boundary + "\r\n"
              + "Content-Disposition: form-data; name=\"uploadfile\"; filename=\"" + currentFileName + "\"\r\n"
              + "Content-Type: application/octet-stream\r\n"
              + "Content-Transfer-Encoding: binary\r\n";              
            
            long   fileLength  = f.length() + tail.length();                          
            String fileHeader2 = "Content-length: " + fileLength + "\r\n";
            String fileHeader  = fileHeader1 + fileHeader2 + "\r\n";   
            
            /*
             * non-binary part of message
             */
            String stringData = metadataPart + fileHeader;
            
            /*
             * Length of whole request 
             */
            long requestLength = stringData.length() + fileLength ;
            conn.setRequestProperty("Content-length", "" + requestLength );

            /*
             * prevent buffering so that the progress bar actually 
             * displays the upload progress
             */
            conn.setFixedLengthStreamingMode((int) requestLength );
            
            /*
             * Connect to the server.
             */
            conn.connect();             
            
            /*
             * Initialize output stream
             */
            DataOutputStream out = new DataOutputStream( conn.getOutputStream() );
            
            /*
             * write header 
             */
            out.writeBytes(stringData);                            
            out.flush();
            
            /* 
             * write data and update progress bar
             */
            uploadDisplayer.iniProgress(0, (int) f.length());
            
            int progress = 0;
            int bytesRead = 0;
            byte b[] = new byte[1024];
            BufferedInputStream bufin = new BufferedInputStream(new FileInputStream(f));
            while ((bytesRead = bufin.read(b)) != -1) 
            {
              
              /*
               * check for interrupt
               */
              if ( Thread.currentThread().isInterrupted() )
              {
                // there could be some exception thrown
              }
              
              
              /*
               * write output
               */
              out.write(b, 0, bytesRead); 
              out.flush();
              progress += bytesRead;
              
              /*
               * update progress bar
               */
              final int p = progress;
              SwingUtilities.invokeLater( new Runnable(){
                public void run()
                {
                  uploadDisplayer.onProgress(p);
                }
              });   

            }
            
            /*
             * Write closing boundary and close stream
             */
            out.writeBytes(tail);
            out.flush();
            out.close();
            
            /*
             * Get server response
             */
            BufferedReader rd = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String line;
            while ((line = rd.readLine()) != null) 
            {
              final String l = line;
              SwingUtilities.invokeLater( new Runnable(){
                public void run()
                {
                  uploadDisplayer.display( l + "<br>" );
                }
              });
            }
             
            
            responseStatusCode = conn.getResponseCode();
            
            try 
            {
              /*
               * If we got a 401 (unauthorized), we can't get that data. We will
               * get an IOException. This makes no sense since a 401 does not
               * consitute an IOException, it just says we need to provide the
               * username again.
               */
              int responseCode        = conn.getResponseCode();
              String responseMessage  = conn.getResponseMessage();
            } 
            catch (IOException ioe) 
            {
                System.out.println(ioe.getMessage());
            }
    
            //System.out.println("conn.getResponseCode(): " + responseCode);
            //System.out.println("conn.getResponseMessage(): " + responseMessage);   
          } 
          catch (Exception e) 
          {
           uploadDisplayer.display("<font color=red>An error occurred: "+e.getMessage()+"</font>");
            e.printStackTrace();
          } 
          finally 
          {
            /*
             * disconnect from the server
             */
            if (conn != null) conn.disconnect();
          }
        }
		
	}

}
