package petruna.sps;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItemHeaders;
import org.apache.commons.fileupload.FileItemIterator;
import org.apache.commons.fileupload.FileItemStream;
import org.apache.commons.fileupload.FileUploadBase;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.apache.commons.fileupload.util.Streams;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.Iterator;
import java.util.UUID;



public class Servlet extends HttpServlet {
	
	public static final String STORAGE_DIRECTORY_INIT_PARAM_NAME = "STORAGE_DIRECTORY";
	
	private File storageDirectory;
	
	
	
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
	
		try {
			boolean isMultipart = ServletFileUpload.isMultipartContent(request);
			if(isMultipart) {
				ServletFileUpload upload = new ServletFileUpload();
	            System.out.println("doPost called, within Multipart");
				FileItemIterator iter = upload.getItemIterator(request);
				while (iter.hasNext()) {
					 System.out.println("  iterating");
				    FileItemStream item = iter.next();					    
				    if(!item.isFormField()) {
				        saveToFile(item);
				    }else {
				    }
				}
			}
		} catch (FileUploadException e) {
			throw new ServletException("File upload failed.", e);
		}
		
	}
	
	private void saveToFile(FileItemStream item) throws FileNotFoundException, IOException {
		
       File file = new File(this.storageDirectory, item.getName());//
		FileOutputStream out = null;
		try {
			out = new FileOutputStream(file);
			Streams.copy(item.openStream(), out, true);
			log(String.format("File [%s] saved to repository", file));
		} finally {
			if(out != null) {
				try {
					out.close();
				} catch (IOException ex) {
					// nothing useful can be done here, ignore the exception
				}
			}
		}
	}



	@Override
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
		String storageDirectoryPath = config.getInitParameter(STORAGE_DIRECTORY_INIT_PARAM_NAME);
		if(storageDirectoryPath == null) {
			throw new ServletException("Storage directory for uploaded files was not set in <servlet-init> element in web.xml, key=" + STORAGE_DIRECTORY_INIT_PARAM_NAME);
		}
		this.storageDirectory = new File(storageDirectoryPath);
		if(!storageDirectory.isDirectory()) {
			throw new ServletException("Storage directory is not a proper directory: " + storageDirectoryPath);
		}
	}
	

}
